#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QWidget>
# include <QVBoxLayout>
# include <QHBoxLayout>
# include <QLineSeries>
# include <QLineEdit>
# include <QIntValidator>
# include <QDoubleValidator>
# include <QPushButton>
# include <QChart>
# include <QChartView>
# include <QMessageBox>
# include <pso.h>
#include <QScatterSeries>
# include <QLabel>
using namespace QtCharts;

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private:
    QVBoxLayout *mainLayout;
    QWidget *mainWidget;
    QLineEdit *particleEdit;
    QLineEdit *generationsEdit;
    QLineEdit *weightEdit,*c1Edit,*c2Edit;
    QPushButton *stepButton;
    QPushButton *setButton;
    QLabel *bestLabel;
    QLabel *generationLabel;
    Pso *algorithm;
    QChart *chart;
    QChartView *chartView;
    QScatterSeries *pointSeries;
    int currentGeneration;
public slots:
    void stepslot();
    void setSlot();
};

#endif // MAINWINDOW_H
