#include "problem.h"
Problem::Problem(int d)
{
    dimension=d;
    leftMargin.resize(d);
    rightMargin.resize(d);
}

void    Problem::setLeftMargin(Data x)
{
    leftMargin=x;
}

void    Problem::setRightMargin(Data x)
{
    rightMargin=x;
}

int     Problem::getDimension() const
{
    return dimension;
}

Data    Problem::getLeftMargin() const
{
    return leftMargin;
}

Data    Problem::getRightMargin() const
{
    return rightMargin;
}

void    Problem::bound(Data &x)
{
    int i;
    for(i=0;i<x.size();i++)
    {
        if(x[i]>rightMargin[i]) x[i]=rightMargin[i];
        if(x[i]<leftMargin[i])  x[i]=leftMargin[i];
    }
}

Data    Problem::getSample()
{
    Data x;
    x.resize(dimension);
    int i;
    for(i=0;i<x.size();i++)
    {
        x[i]=leftMargin[i]+(rand() *1.0/RAND_MAX)*(rightMargin[i]-leftMargin[i]);
    }
    return x;
}

Problem::~Problem()
{

}
