#ifndef PROBLEM_H
#define PROBLEM_H

# include <QVector>
# include <QString>

typedef QVector<double> Data;
class Problem
{
private:
    int dimension;
    Data leftMargin;
    Data rightMargin;
public:
    Problem(int d);
    void setLeftMargin(Data x);
    void setRightMargin(Data x);
    int     getDimension() const;
    Data    getLeftMargin() const;
    Data    getRightMargin() const;
    Data getSample();
    void    bound(Data &x);
    virtual double funmin(Data &x)=0;
    virtual ~Problem();
};

#endif // PROBLEM_H
