#include "pso.h"
Pso::Pso(int count,Problem *p)
{
    problem=p;
    particle.resize(count);
    bestParticle.resize(count);
    fitnessArray.resize(count);
    bestFitnessArray.resize(count);
    velocity.resize(count);
    for(int i=0;i<count;i++)
    {
        particle[i]=problem->getSample();
        bestParticle[i]=particle[i];
        fitnessArray[i]=problem->funmin(particle[i]);
        bestFitnessArray[i]=fitnessArray[i];
        if(i==0)
        {
            bestf=fitnessArray[i];
            bestg=particle[i];
        }
        if(fitnessArray[i]<bestf)
        {
            bestf=fitnessArray[i];
            bestg=particle[i];
        }
        velocity[i].resize(problem->getDimension());
        for(int j=0;j<problem->getDimension();j++)
            velocity[i][j]=rand() *1.0/RAND_MAX;
    }
    weight=0.5;
    c1=1.0;
    c2=1.0;
}

void    Pso::setc1(double c)
{
    c1=c;
}

void    Pso::setc2(double c)
{
    c2=c;
}

double  Pso::getc1() const
{
    return c1;
}

double  Pso::getc2() const
{
    return c2;
}

void    Pso::setweight(double w)
{
    weight=w;
}

double  Pso::getweight() const
{
    return weight;
}
void    Pso::nextGeneration()
{
    int i,j;
    for(i=0;i<particle.size();i++)
    {
        fitnessArray[i]=problem->funmin(particle[i]);
        if(fitnessArray[i]<bestFitnessArray[i])
        {
            bestFitnessArray[i]=fitnessArray[i];
            bestParticle[i]=particle[i];
        }
        if(fitnessArray[i]<bestf)
        {
            bestf=fitnessArray[i];
            bestg=particle[i];
        }
    }
    for(i=0;i<particle.size();i++)
    {
        for(j=0;j<problem->getDimension();j++)
        {

           velocity[i][j]=weight * velocity[i][j]+
                    c1 * rand() *1.0/RAND_MAX*(bestParticle[i][j]-particle[i][j])+
                    c2 * rand() *1.0/RAND_MAX*(bestg[j]-particle[i][j]);
            particle[i][j]=particle[i][j]+velocity[i][j];
        }
       problem->bound(particle[i]);
    }
}

void    Pso::getParticle(int index,Data &x,double &y)
{
     x=particle[index];
     y=fitnessArray[index];
}

Data    Pso::getBest()
{
    return bestg;
}

double  Pso::getBestFitness()
{
    return bestf;
}
